<?php
/***************************************************************
*  Copyright notice
*  
*  (c) 2003 Norman Seibert (seibert@eumedia.de)
*  All rights reserved
*
*  This script is part of the Typo3 project. The Typo3 project is 
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
* 
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
* 
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/** 
 * Plugin 'Birthday List' for the 'eu_birthdays' extension.
 *
 * @author	Norman Seibert <seibert@eumedia.de>
 */

require_once(PATH_tslib.'class.tslib_pibase.php');

class tx_eubirthdays_pi1 extends tslib_pibase {
	var $cObj;		// The backReference to the mother cObj object set at call time
	
	var $prefixId = 'tx_eubirthdays_pi1';		// Same as class name
	var $scriptRelPath = 'pi1/class.tx_eubirthdays_pi1.php';	// Path to this script relative to the extension dir.
	var $extKey = 'eu_birthdays';	// The extension key.
	
	var $conf;
	var $config;
	var $pid;
	var $typolink_conf=array();
	
	/**
	 * [Put your description here]
	 */
	function main($content,$conf)	{
		
		$this->conf = $conf;
		
		$this->pi_setPiVarDefaults();
		
		// pid_list is the pid/list of pids from where to fetch the news items.
		$this->config['pid_list'] = trim($this->cObj->stdWrap($this->conf['pid_list'],$this->conf['pid_list.']));
		$this->config['pid_list'] = $this->config['pid_list'] ? implode(t3lib_div::intExplode(',',$this->config['pid_list']),',') : $GLOBALS['TSFE']->id;
		$this->config['recursive'] = $this->cObj->stdWrap($conf['recursive'],$conf['recursive.']);
		$this->pid = $this->config['pid_list'];
		
		$this->initRecursive($this->config['recursive'], $this->pid);
		
		// TypoLink.
		$this->typolink_conf = $this->conf['typolink.'];
		$this->typolink_conf['parameter.']['current'] = 1;
		$this->typolink_conf['additionalParams'] = $this->cObj->stdWrap($this->typolink_conf['additionalParams'],$this->typolink_conf['additionalParams.']);
		unset($this->typolink_conf['additionalParams.']);

		// *************************************
		// *** doing the things...:
		// *************************************
		$this->dontParseContent = $this->conf['dontParseContent'];
		$this->local_cObj =t3lib_div::makeInstance('tslib_cObj');		// Local cObj.
		
		//$GLOBALS['TSFE']->set_no_cache();
		
		$content.= $this->birthday_list();
		return $this->pi_wrapInBaseClass($content);
	}

	function birthday_list() {
		$now = getdate();
		$past = $now[0]-$this->conf['past']*24*3600;
		$future = $now[0]+$this->conf['future']*24*3600;
		$date_past = getdate($past);
		$date_future = getdate($future);
		
		$mysql_date = $this->conf['mysql_date'];
		$mysql_date = str_replace('.', '\.', $mysql_date);
		$mysql_date = str_replace('-', '\-', $mysql_date);
		$mysql_date = str_replace('%d', '([0-9]{1,2})', $mysql_date);
		$mysql_date = str_replace('%m', '([0-9]{1,2})', $mysql_date);
		$mysql_date = str_replace('%y', '([0-9]{0,4}[^0-9]{0,4})', $mysql_date);
		
		$dateorder = str_replace('%', '', $this->conf['mysql_date']);
		$dateorder = ereg_replace('[^dmy]', '', $dateorder);
		
		$out = $this->conf["append"];
		$out .= '<table '.$this->conf["tableParams"].'>';
		
		$query = 'SELECT * FROM fe_users WHERE pid IN ('.$this->pid.') AND LENGTH(tx_vafeuser_birthday) > 0';
		$res = mysql(TYPO3_db,$query);
		echo mysql_error();
		
		$arrRows = array();
		$i = 0;
		while($row = mysql_fetch_assoc($res)) {
			if (ereg($mysql_date, $row['tx_vafeuser_birthday'], $arrMatches)) {
				for ($jj=1; $jj<count($arrMatches); $jj++) {
					switch (substr($dateorder, $jj-1, 1)) {
						case 'd':
							$day = $arrMatches[$jj];
						break;
						case 'm':
							$month = $arrMatches[$jj];
						break;
					}
				}
			} else {
				exit;
			}
			$thisBirthday = strtotime($now['year'].'-'.$month.'-'.$day);
			$bolShow = false;
			if (($thisBirthday > $past) && ($thisBirthday < $future)) {
				$bolShow = true;
			} elseif ($date_past['year'] != $now['year']) {
				$thisBirthday = strtotime(($now['year']-1).'-'.$month.'-'.$day);
				if (($thisBirthday > $past) && ($thisBirthday < $future)) $bolShow = true;
			} elseif ($date_future['year'] != $now['year']) {
				$thisBirthday = strtotime(($now['year']+1).'-'.$month.'-'.$day);
				if (($thisBirthday > $past) && ($thisBirthday < $future)) $bolShow = true;
			}
			if ($bolShow) {
				$arrRows[$i]['uid'] = $row['uid'];
				$arrRows[$i]['name'] = trim($row['tx_vafeuser_prename'].' '.$row['name']);
				$arrRows[$i]['birthday'] = $thisBirthday;
				$i++;
			}
		}
		
		if (count($arrRows) > 0) $arrRows = $this->array_csort($arrRows, 'birthday');
		
		for ($i=0; $i<count($arrRows); $i++) {
			$date = getdate($arrRows[$i]['birthday']);
			$this->local_cObj->setCurrentVal($this->conf['PIDFEuser']);
			$temp_conf = $this->typolink_conf;
			$temp_conf['additionalParams']='&tx_newloginbox_pi3[showUid]='.$arrRows[$i]['uid'];
			$temp_conf['additionalParams'].='&no_cache=1';
			$arrLink = $this->local_cObj->typolinkWrap($temp_conf);
			$out .= '<tr>
				<td valign=top>'
					.((($date['mon'] == $now['mon']) && ($date['mday'] == $now['mday'])) ? $this->local_cObj->stdWrap($this->local_cObj->stdWrap($arrRows[$i]['birthday'], $this->conf['date_stdWrap.']), $this->conf['today_stdWrap.']) : $this->local_cObj->stdWrap($arrRows[$i]['birthday'], $this->conf['date_stdWrap.'])).
				'</td>
				<td valign=top>'
					.((($date['mon'] == $now['mon']) && ($date['mday'] == $now['mday'])) ? $this->local_cObj->stdWrap($arrLink[0].$arrRows[$i]['name'].$arrLink[1], $this->conf['today_stdWrap.']) : $arrLink[0].$arrRows[$i]['name'].$arrLink[1]).
				'</td>
			</tr>';
		}
		
		$out .= '</table>';
		
		return $out;
	}
	
	function array_csort() {  //coded by Ichier2003
	    $args = func_get_args();
	    $marray = array_shift($args);
	
	    $msortline = "return(array_multisort(";
	    foreach ($args as $arg) {
	        $i++;
	        if (is_string($arg)) {
	            foreach ($marray as $row) {
	                $sortarr[$i][] = $row[$arg];
	            }
	        } else {
	            $sortarr[$i] = $arg;
	        }
	        $msortline .= "\$sortarr[".$i."],";
	    }
	    $msortline .= "\$marray));";
	
	    eval($msortline);
	    return $marray;
	}
	
	/**
	 * Extends the internal pid_list by the levels given by $recursive
	 */
	function initRecursive($recursive, &$list)	{
		if ($recursive)	{		// get pid-list if recursivity is enabled
			$pid_list_arr = explode(',',$list);
			$list='';
			while(list(,$val)=each($pid_list_arr))	{
				$list.=$val.','.$this->cObj->getTreeList($val,intval($recursive));
			}
			$list = ereg_replace(",$",'',$list);
		}
	}
}



if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/eu_birthdays/pi1/class.tx_eubirthdays_pi1.php'])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/eu_birthdays/pi1/class.tx_eubirthdays_pi1.php']);
}

?>